ENDPOINT="https://api-east1.openhosting.com"
OHAUTH=ENV['OHAUTH']

if ( OHAUTH.nil? )
  raise "Please set the OHAUTH environment variable to your user UUID and secret key"
end

s = OHAUTH.split(':')

USERNAME = s[0]
PASSWORD = s[1]

class OHConnection
  include Faraday
  # remember, this is a method, not a symbol and takes a symbol to a method as arguments!
  attr_accessor :connect

  @@conn = Faraday.new( :url => ENDPOINT, :headers => {"Content-Type" => "application/json", "Accept" => "application/json"}) do |faraday|
    # Prolly will be relevant!
    # https://github.com/lostisland/faraday/wiki/Setting-up-SSL-certificates
    faraday.ssl
    faraday.request :multipart
    faraday.request :url_encoded
    faraday.response :logger
    faraday.adapter :patron
    faraday.basic_auth USERNAME, PASSWORD
  end

  def self.connect
    return @@conn
  end
end
